﻿using System;
using System.Xml;
using System.Configuration;
using System.DirectoryServices;
using System.DirectoryServices.AccountManagement;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using DynamicwebADIntegration.Entities;

namespace DynamicwebADIntegration
{    
    /// <summary>
    /// Summary description for ActiveDirectoryService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class ADIntegrationService : System.Web.Services.WebService
    {
        [WebMethod]
        public string GetData(string importGroupID)
        {
            string ret = string.Empty;                       

            List<User> users = ADHelper.GetAllUsers();
            List<Group> groups = ADHelper.GetGroupsFromUsers(users);
            XmlDocument response = XmlFormatter.GetUsersGroupsXml(users, groups, importGroupID);

            string token = ConfigurationManager.AppSettings["SecurityToken"];
            if (!string.IsNullOrEmpty(token))
            {
                ret = Crypto.EncryptStringAES(response.OuterXml, token);
            }
            else
            {
                ret = response.OuterXml;
            }
            return ret;
        }

        [WebMethod]
        public bool AuthenticateUser(string userName, string password)
        {
            string token = ConfigurationManager.AppSettings["SecurityToken"];
            if (!string.IsNullOrEmpty(token))
            {
                return ADHelper.AuthenticateUser(Crypto.DecryptStringAES(userName, token), Crypto.DecryptStringAES(password, token));
            }
            else
            {
                return ADHelper.AuthenticateUser(userName, password);
            }            
        }
    }
    
}
